/**
----------------------------------------------------------------------------
|            |===============================================|             |
|            |                Custom Map Icons               |             |
|            |============================ v1.1 =============|             |
|                                                                          |
|	   	     |=== Authors: ==================================|             |
|		     |=> Aleks10(Vinny, Void)(Aleksey.al09@gmail.com)|             |
|            |=> Romanius               (romanius@namba.kg)  |             |
|	 	     |===============================================|             |
|                                                                          | 
|   This script is free software: you can redistribute it and/or modify    |
|   it under the terms of the GNU General Public License as published by   |
|   the Free Software Foundation, either version 3 of the License, or      |
|   (at your option) any later version.                                    |
|                                                                          |
|   This script is distributed in the hope that it will be useful,         |
|   but WITHOUT ANY WARRANTY; without even the implied warranty of         |
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
|   GNU General Public License for more details.                           |
|                                                                          |
|   You should have received a copy of the GNU General Public License      |
|   along with this script.  If not, see <http://www.gnu.org/licenses/>.   |
|																		   |
----------------------------------------------------------------------------
**/

#if defined _cust_ico_included
	#endinput
#endif
#define _cust_ico_included

#include <a_samp>
#include <r_io>

#define MAX_CUSTOM_MAP_ICONS 100 //   :)

enum cMapIconInfo
{
	pixel[256],
	gzoneId[256],
	Float:posX,
	Float:posY,
	Float:zX[256],
	Float:zY[256],
	Float:zX1[256],
	Float:zY1[256],
	Float:streamDistance,
	bool:isUsed,
	bool:isShown,
	len
}

new customMapIcon[MAX_CUSTOM_MAP_ICONS][cMapIconInfo];

stock DestroyCustomMapIcon(iconid)
{
	if(!customMapIcon[iconid][isUsed]) return;

	for(new i; i < customMapIcon[iconid][len]; i++)
	{
		if(customMapIcon[iconid][isShown])
			GangZoneDestroy(customMapIcon[iconid][gzoneId][i]);
		
		customMapIcon[iconid][pixel][i] = 0;
	}
	
	customMapIcon[iconid][isShown] = false;
	customMapIcon[iconid][isUsed] = false;
}

stock loadIcon(filename[], Float:X, Float:Y, Float:Size = 24.0, Float:distance = 1000.0)
{
	new curentIconId;
	
	while(customMapIcon[curentIconId][isUsed]) curentIconId++;

	if(curentIconId >= MAX_CUSTOM_MAP_ICONS) return -1;

	new tmp[64];
	format(tmp, 64, "%s.dbi", filename);
	new File:f = fopen(tmp, io_read);
	new c = 0;
	new pix[20][5];
	while (fread(f, tmp))
	{
		split(tmp, pix, ' ');
		customMapIcon[curentIconId][pixel][c] = strval(pix[4]);
		customMapIcon[curentIconId][zX][c] = X+strval(pix[0])*Size;
		customMapIcon[curentIconId][zY][c] = Y+(strval(pix[1])-16)*Size;
		customMapIcon[curentIconId][zX1][c] = X+strval(pix[2])*Size;
		customMapIcon[curentIconId][zY1][c] = Y+(strval(pix[3])-16)*Size;
		c++;
	}
	
	fclose(f);
	customMapIcon[curentIconId][isUsed] = true;
	customMapIcon[curentIconId][len] = c;
	customMapIcon[curentIconId][posX] = X;
	customMapIcon[curentIconId][posY] = Y;
	customMapIcon[curentIconId][streamDistance] = distance;
	printf("[Custom Icon] -> Icon %s created! Gangzones used: %d (%.1f%%)", 
			filename, c, (100.0 / 256.0) * float(c));
	fclose(f);
	return c;
}

stock SetupCustomIconStreamer(ms = 1000)
{
	SetTimer("custMapICOStreamer", ms, 1);
}

forward custMapICOStreamer();
public custMapICOStreamer()
{
	static showedIcons;

	for(new p = GetMaxPlayers(); p >= 0; --p)
	{
		if(!IsPlayerConnected(p) && GetPlayerState(p) != PLAYER_STATE_SPAWNED) continue;
	
		for(new i = 0; i < MAX_CUSTOM_MAP_ICONS; i++)
		{
			if(!customMapIcon[i][isUsed]) continue;
			
			if(IsPlayerInRangeOfPoint(p, customMapIcon[i][streamDistance], customMapIcon[i][posX], customMapIcon[i][posY], 0.0))
			{
				if (showedIcons + customMapIcon[i][len] > MAX_GANG_ZONES) continue;
				
				if(customMapIcon[i][isShown]) continue;
				
				showedIcons+=customMapIcon[i][len];
				for(new g=0; g < customMapIcon[i][len];g++)
				{
					customMapIcon[i][gzoneId][g] = GangZoneCreate(customMapIcon[i][zX][g], customMapIcon[i][zY][g], customMapIcon[i][zX1][g], customMapIcon[i][zY1][g]);
						
					GangZoneShowForPlayer(p, customMapIcon[i][gzoneId][g], customMapIcon[i][pixel][g]);
				}
				customMapIcon[i][isShown] = true;
			}
			else
			{
				if(!customMapIcon[i][isShown]) continue;
					
				showedIcons-=customMapIcon[i][len];
				for(new g; g < customMapIcon[i][len]; g++)
				{
					//GangZoneHideForPlayer(j, customMapIcon[i][gzoneId][g]);
					GangZoneDestroy(customMapIcon[i][gzoneId][g]);
				}

				customMapIcon[i][isShown] = false;
			}
		}
	}
	
	return;
}


#undef MAX_CUSTOM_MAP_ICONS