/**
----------------------------------------------------------------------------
|            |===============================================|             |
|            |              Custom Icons Parser              |             |
|            |============================ v0.1 =============|             |
|                                                                          |
|	   	     |=== Authors: ==================================|             |
|		     |=> Aleks10(Vinny, Void)(Aleksey.al09@gmail.com)|             |
|            |=> Romanius               (romanius@namba.kg)  |             |
|	 	     |===============================================|             |
|                                                                          | 
|   This script is free software: you can redistribute it and/or modify    |
|   it under the terms of the GNU General Public License as published by   |
|   the Free Software Foundation, either version 3 of the License, or      |
|   (at your option) any later version.                                    |
|                                                                          |
|   This script is distributed in the hope that it will be useful,         |
|   but WITHOUT ANY WARRANTY; without even the implied warranty of         |
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
|   GNU General Public License for more details.                           |
|                                                                          |
|   You should have received a copy of the GNU General Public License      |
|   along with this script.  If not, see <http://www.gnu.org/licenses/>.   |
|																		   |
----------------------------------------------------------------------------
**/

#if defined _cust_ico_included
	#endinput
#endif
#define _cust_ico_included

#include <a_samp>
#include <r_io>

enum eIc {
	col,
	stat
};
new ico[256][eIc], iLen = 0;
new File:fc;

stock recursionMany(j)
{
	if (ico[j][stat] == 0) {
		ico[j][stat] = 1;
		new ii = j / 16,
			jj = j - ii * 16;
		if (jj < 15 && (ico[j+1][col] == ico[j][col]) && ico[j+1][stat] == 0)
			recursionMany(j+1);
		if (jj > 0  && (ico[j-1][col] == ico[j][col]) && ico[j-1][stat] == 0)
			recursionMany(j-1);
		if (ii < 15 && (ico[j+16][col] == ico[j][col]) && ico[j+16][stat] == 0)
			recursionMany(j+16);
		if (ii > 0  && (ico[j-16][col] == ico[j][col]) && ico[j-16][stat] == 0)
			recursionMany(j-16);
	}
}

stock isRecHave(a, b, &square, color, pixs[4])
{
	new i1 = a / 16,		// a y
		j1 = a - i1 * 16,	// a x
		i2 = b / 16,		// b y
		j2 = b - i2 * 16; 	// b x
	if (j1 > j2) { new t = j2; j2 = j1; j1 = t; }
	if (i1 > i2) { new t = i2; i2 = i1; i1 = t; }
	for (new i=i1;i<=i2;i++)
		for (new j=j1;j<=j2;j++)
			if (ico[i*16+j][col] != color || 
				ico[i*16+j][stat] != 1)
				return false;
	if (square > (i2-i1+1)*(j2-j1+1)) return false;
	else square = (i2-i1+1)*(j2-j1+1);
	pixs[0] = j1;
	pixs[1] = i1;
	pixs[2] = j2+1;
	pixs[3] = i2+1;
	return true;
}

stock calcImg()
{
	new str[128];
	for (new i=0;i<256;i++) {
		if (ico[i][stat] == 2) continue;
		for (new j=0;j<256;j++)
			if (ico[j][stat] == 1)
				ico[j][stat] = 0;
		recursionMany(i);
		new maxSq = 0,
			tmpSq[4];
		for (new a=0;a<256;a++)
			for (new b=0;b<256;b++)
				isRecHave(a, b, maxSq, ico[i][col], tmpSq);
		if (maxSq == 0) continue;
		if ((ico[tmpSq[1]*16+tmpSq[0]][col] & 0xFF) <= 0x10) continue;
		for (new a = tmpSq[1]; a < tmpSq[3]; a++)
			for (new b = tmpSq[0]; b < tmpSq[2]; b++)
				ico[a*16+b][stat] = 2;
		iLen++;
		format(str, 32, "%d %d %d %d %d\n", tmpSq[0], tmpSq[1], tmpSq[2], tmpSq[3], ico[tmpSq[1]*16+tmpSq[0]][col]);
		fwrite(fc, str);
	}
}

stock iconParse(filename[])
{
	new str[64];
	format(str, 64, "%s.ico", filename);
	new File:f = fopen(str, io_read);
	new reserved = readInt16(f);
	new type	 = readInt16(f);
	new count	 = readInt16(f);
	if((reserved != 0 && type != 1) || count <= 0)
	{
		printf("[Custom Icon] -> Invalid ICO file! Filename %s", filename);
		fclose(f);
		return;
	}
	new width;
	new heigth;
	new image_offset;
	for(new i; i < count; i++)
	{
		width = readByte(f);
		heigth = readByte(f);
		fseek(f, 4, seek_current);
		new bit_count = readInt16(f);
		fseek(f, 4, seek_current);
		image_offset = readInt32(f);
		if(bit_count != 32 || (width != 16 && heigth != 16)) continue;
		fseek(f, image_offset + 40);
		for(new j=0; j < 256; j++)
		{
			new color[4 char];
			color{0} = readByte(f); // B
			color{1} = readByte(f); // G
			color{2} = readByte(f); // R
			color{3} = readByte(f); // A
			ico[j][col] = (color{2} << 24 | color{1} << 16 | color{0} << 8 | color{3});
			ico[j][stat] = 0;
		}
		
		fclose(f);
		
		format(str, 64, "%s.dbi", filename);
		fc = fopen(str, io_write);
		
		iLen = 0;
		
		// 
		
		new fl[256] = {0}, vh[256] = {0}, foncol = 0;
		for (new j=0; j < 256; j++)
		{
			if (fl[j] == 0) {
				for (new k=0; k < 256; k++) 
				{
					if (ico[j][col] == ico[k][col] && fl[k] == 0) {
						vh[j] ++;
						fl[k] = 1;
					}
				}
				fl[j] = 1;
			}
		}
		new maxv=0, idm = 0;
		for (new j=0;j<256;j++) 
		{
			if (maxv < vh[j]) 
			{
				maxv = vh[j];
				idm = j;
			}
		}
		foncol = ico[idm][col]; //  !
		
		if ((foncol & 0xFF) > 0x10) {
			for (new j=0;j<256;j++)
				if (ico[j][col] == foncol) 
					ico[j][stat] = 2;
			format(str, 32, "0 0 16 16 %d\n", foncol);
			fwrite(fc, str);
			iLen++;
		}
		
		calcImg();
		printf("[Custom Icon] -> Icon %s parsed! Gangzones used: %d (%.1f%%)", 
				filename, iLen, (100.0 / 256.0) * float(iLen));
				
		fclose(fc);
		
		return;
	}
	
	fclose(f);
	
	printf("[Custom Icon] -> Cant find any 16x16 32bit icon");
	
	return;
}